-- Include libraries
push = require('libs.push')
gamera = require('libs.gamera')
require('libs/ColorLibrary')

-- Include gameparts
require("editor.editor")


function love.load() 
  -- Profiler
  --[[
  love.profiler = require('libs.profile') 
  love.profiler.hookall("Lua")
  love.profiler.start()
  --]]
  
  -- Love2d configuration
  -- Keys held down repeat sending their commands 
  love.keyboard.setKeyRepeat(true)
  
  -- Push setup
  gameWidth, gameHeight = 1920, 1080
  windowWidth, windowHeight = love.window.getDesktopDimensions()  
  --windowWidth, windowHeight = windowWidth*.7, windowHeight*.7 --make the window a bit smaller than the screen itself
  push:setupScreen(gameWidth, gameHeight, windowWidth, windowHeight, {fullscreen = true, pixelperfect = false, resizable = true})
    
  EditorSetup()
end

function love.draw()
    push:apply("start")
      EditorDraw()
    
    push:apply("end")
    
    --love.graphics.print(love.report or "Please wait...")
end

love.frame = 0
function love.update(dt)
  --[[love.frame = love.frame + 1
  if love.frame%100 == 0 then
    love.report = love.profiler.report('time', 20)
    love.profiler.reset()
  end
  --]]
  
  EditorUpdate(dt)
  
end

function love.resize(w, h)
  push:resize(w, h)
end


-- General Mouse events

function love.mousepressed(x,y,k)
  push:apply("start")

  -- convert mouse position according to scaling
  local MouseX, MouseY = push:toGame(x, y)
  if MouseX == nil then
    MouseX = 0
  end
  if MouseY == nil then
    MouseY = 0
  end
  
  if k == 1 then
    if MouseX > 1 and MouseX < 80 and MouseY > 1 and MouseY < 50 then -- Checks if the mouse is on the button
      print("Exit Button pressed")
      love.event.quit()
    else
      print("Somewhere else clicked" .. MouseX .. " " .. MouseY)
    end
  end
  push:apply("end")
end

function love.wheelmoved(x, y)
  if y > 0 then
      zoom('+')
  elseif y < 0 then
      zoom('-')
  end
end


-- General Keyboard events

function love.keypressed(key)
  if key == 'escape' then 
    love.event.quit() 
  elseif key == '+' then
    zoom('+')
  elseif key == '-' then
    zoom('-')
  end
  
end